
/**************************************************************************
 *
 * Copyright 2016 Samsung Electronics co., Ltd. All Rights Reserved.
 *
 * Contact: Konstantin Drabeniuk <k.drabeniuk@samsung.com>
 * Contact: Andrii Sokolenko <a.sokolenko@samsung.com>
 * Contact: Roman Marchenko <r.marchenko@samsung.com>
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sub license, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice (including the
 * next paragraph) shall be included in all copies or substantial portions
 * of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT.
 * IN NO EVENT SHALL PRECISION INSIGHT AND/OR ITS SUPPLIERS BE LIABLE FOR
 * ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
**************************************************************************/

#include "tc_tbm.h"

TEST(TBMLog, logPrintf)
{
	tbm_log_enable_color(1);
	tbm_log_enable_dlog(0);
	tbm_log_set_debug_level(2);
	tbm_log_set_path("/tmp/tbm.log");
	tbm_log_print(TBM_LOG_LEVEL_ERR, "haltest\n");
	tbm_log_print(TBM_LOG_LEVEL_WRN, "haltest\n");
	tbm_log_print(TBM_LOG_LEVEL_INFO, "haltest\n");
	tbm_log_print(TBM_LOG_LEVEL_DBG, "haltest\n");
	tbm_log_set_path(NULL);
}

TEST(TBMLog, logSetPath)
{
	tbm_log_enable_dlog(0);
	tbm_log_set_path("/tmp/tbm.log");
	tbm_log_print(TBM_LOG_LEVEL_ERR, "hello\n");
	tbm_log_set_path(NULL);
}

TEST(TBMLog, logDlogNone)
{
	tbm_log_enable_color(0);
	tbm_log_enable_dlog(1);
	tbm_log_set_debug_level(0);
	tbm_log_print(TBM_LOG_LEVEL_ERR, "haltest");
	tbm_log_print(TBM_LOG_LEVEL_WRN, "haltest");
	tbm_log_print(TBM_LOG_LEVEL_INFO, "haltest");
	tbm_log_print(TBM_LOG_LEVEL_DBG, "haltest");
}

TEST(TBMLog, logDlog)
{
	tbm_log_enable_dlog(1);
	tbm_log_print(TBM_LOG_LEVEL_ERR, "haltest");
	tbm_log_print(TBM_LOG_LEVEL_WRN, "haltest");
	tbm_log_print(TBM_LOG_LEVEL_INFO, "haltest");
	tbm_log_print(TBM_LOG_LEVEL_DBG, "haltest");
}

TEST(TBMLog, logDlogNormal)
{
	tbm_log_enable_dlog(1);
	tbm_log_print(TBM_LOG_LEVEL_ERR, "haltest");
	tbm_log_print(TBM_LOG_LEVEL_WRN, "haltest");
	tbm_log_print(TBM_LOG_LEVEL_INFO, "haltest");
	tbm_log_print(TBM_LOG_LEVEL_DBG, "haltest");
}

TEST(TBMLog, logDlogUnknownLevel)
{
	tbm_log_enable_dlog(1);
	tbm_log_print(TBM_UT_INVALID_VALUE, "haltest");
}

TEST(TBMLog, logSetAssertLevel)
{
	tbm_log_enable_dlog(1);
	tbm_log_set_assert_level(TBM_LOG_LEVEL_ERR);
	tbm_log_set_assert_level(TBM_LOG_LEVEL_WRN);
	tbm_log_set_assert_level(TBM_LOG_LEVEL_INFO);
	tbm_log_set_assert_level(TBM_LOG_LEVEL_DBG);
}

TEST(TBMLog, logPrintStdout)
{
	tbm_log_print_stdout(TBM_LOG_LEVEL_ERR, "haltest");
	tbm_log_print_stdout(TBM_LOG_LEVEL_WRN, "haltest");
	tbm_log_print_stdout(TBM_LOG_LEVEL_INFO, "haltest");
	tbm_log_print_stdout(TBM_LOG_LEVEL_DBG, "haltest");
}